import loadingComponent from './components/loading/loading.vue'
export const loading = {
  install(Vue, optinos) {
    let $vm;
    if (!$vm) {
      const LoadingPlugin = Vue.extend(loadingComponent);
      $vm = new LoadingPlugin({
        el: document.createElement('div')
      });
      document.body.appendChild($vm.$el);
    }
    $vm.show = false;
    let loading = {
      show(text) {
        $vm.show = true;
        $vm.text = text || '加載中...';
      },
      hide() {
        $vm.show = false;
      }
    }
    Vue.loading = Vue.prototype.$loading = loading
  }
}

const ch2c = {
  '0': 0, '1': 1, '2': 2, '3': 3, '4': 4, '5': 5, '6': 6, '7': 7, '8': 8, '9': 9, 'a': 10, 'b': 11, 'c': 12, 'd': 13, 'e': 14, 'f': 15, 'g': 16, 'h': 17, 'i': 18, 'j': 19, 'k': 20, 'l': 21, 'm': 22, 'n': 23, 'o': 24, 'p': 25, 'q': 26, 'r': 27, 's': 28, 't': 29, 'u': 30, 'v': 31, 'w': 32, 'x': 33, 'y': 34, 'z': 35, 'A': 36, 'B': 37, 'C': 38, 'D': 39, 'E': 40, 'F': 41, 'G': 42, 'H': 43, 'I': 44, 'J': 45, 'K': 46, 'L': 47, 'M': 48, 'N': 49, 'O': 50, 'P': 51, 'Q': 52, 'R': 53, 'S': 54, 'T': 55, 'U': 56, 'V': 57, 'W': 58, 'X': 59, 'Y': 60, 'Z': 61, '+': 62, '/': 63, '=': 64
}
const c2ch = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '+', '/', '=']
const Base64 = require('js-base64').Base64
export const miYu = {
  /**
 * 加密方法
 * @param data
 * @param key
 * @param expire
 * @return mixed
 */
  encrypt: function (data, key, expire) {
    const myDate = new Date();
    const expireInt = expire ? String(parseInt(expire) + myDate.getTime()).substr(0, 10) : '0000000000';
    const dataEncode = Base64.encode(expireInt + data);
    let x = 0;
    let char = '';
    let str = '';
    for (let i = 0; i < String(dataEncode).length; i++) {
      if (x === String(key).length) {
        x = 0;
      }
      char += String(key).substr(x, 1);
      x++
    }
    for (let i = 0; i < String(dataEncode).length; i++) {
      const d_code = ch2c[String(dataEncode).substr(i, 1)];
      const k_code = ch2c[String(char).substr(i, 1)];
      str += c2ch[(d_code + k_code) % 65]
    }
    let strEncode = Base64.encode(str);
    return String(strEncode).replace(/\+/g, '-').replace(/\//g, '_').replace(/\=/g, '');

  },
  /**
   * 解密方法
   * @param data
   * @param key
   * @return mixed|string
   */
  decrypt: function (data, key) {
    const myDate = new Date();
    let _data = String(data).replace(/-/g, '+').replace(/_/g, '/');
    const mod = _data.length % 4;
    if (mod) {
      _data += '='.repeat(4 - mod)
    }
    const data_base = Base64.decode(_data);
    let x = 0;
    let char = '';
    let str = '';
    for (let i = 0; i < String(data_base).length; i++) {
      if (x === String(key).length) x = 0;
      char += String(key).substr(x, 1);
      x++
    }
    for (let i = 0; i < String(data_base).length; i++) {
      const d_code = ch2c[String(data_base).substr(i, 1)];
      const k_code = ch2c[String(char).substr(i, 1)];
      if (d_code < k_code) {
        str += c2ch[d_code + 65 - k_code]
      } else {
        str += c2ch[d_code - k_code]
      }
    }
    const str_base = Base64.decode(str);
    const expire = String(str_base).substr(0, 10);
    if (expire > 0 && expire < myDate.getTime()) {
      return ''
    }
    return String(str_base).substr(10)
  }
}


import ToastVue from './components/toast/toast.vue'
export const toast = {
  install(Vue, options) {
    const CONSTRUCTOR = Vue.extend(ToastVue)
    const CACHE = {}
    Object.assign(ToastVue.DEFAULT_OPT, options)
    function toasts(msg, options = {}) {
      options.message = msg
      let toastWrap = CACHE[options.id] || (CACHE[options.id] = new CONSTRUCTOR)
      if (!toastWrap.$el) {
        let vm = toastWrap.$mount()
        document.querySelector(options.parent || 'body').appendChild(vm.$el)
      }
      toastWrap.queue.push(options)
    }
    let toast = {
      info: function(msg, options = {className: 'et-warn'}) {
        toasts(msg, options = {className: 'et-warn'})
      },
      error: function(msg, options = {className: 'et-alert'}) {
        toasts(msg, options = {className: 'et-alert'})
      },
      success: function(msg, options = {className: 'et-info'}) {
        toasts(msg, options = {className: 'et-info'})
      }
    }
    Vue.toast = Vue.prototype.$toast = toast
  }
}